<%@Page Language="C#" LCID="2067"%>
<%@Import Namespace="Reuzenhuis.Be.Quiz" %>
<%@ Register TagPrefix="web" TagName="header" Src="\includes\school2-header.ascx" %>
<%@ Register TagPrefix="web" TagName="footer" Src="\includes\school2-footer.ascx" %>
<%@ Reference Control="\includes\quiz\getlogin.ascx" %>
<%@ Reference Control="\includes\quiz\home.ascx" %>
<%@ Reference Control="\includes\quiz\vraag.ascx" %>
<%@ Reference Control="\includes\quiz\rapport.ascx" %>
<web:header id="header" runat="server"/>
<asp:placeholder id="PlaceHolder" runat="server"/>
<div id="outError" runat="server"></div>
<div id="outResult" runat="server"></div>
<web:footer id="footer" runat="server"/>
<script language="C#" runat="server">

	void Page_Load(Object sender, EventArgs e)
	{
		string strResult = "";
		string ac = "getlogin";
		if (Request.Params["ac"] != null) ac = Request.Params["ac"];
		header.titel = "Quiz";
		
		if (ac.Equals("getlogin")){
			if (!Request.HttpMethod.Equals("POST")){
				if (Request.Cookies["deelnemer_quiz_id"] != null) Session["deelnemer_id"] = Request.Cookies["deelnemer_quiz_id"].Value;
				//display Form indien er nog geen deelnemer_id is , anders ga naar home
				if (Session["deelnemer_id"] == null){
					// Call the control to update/insert a new 'Deelnemer'-article
					GetLogin myControl = (GetLogin) Page.LoadControl("includes\\quiz\\getlogin.ascx");
					myControl.deelnemerId = "0"; // 0 --> new
					PlaceHolder.Controls.Add(myControl);
				}else{
					Response.Redirect(Request.Path+"?ac=home");
				} 
				
			}else{
				Session["deelnemer_id"] = null;
				Persoon persoon = new Persoon(Request.Params["deelnemerId"]);
				persoon.setNaam(Request.Params["naam"]);
				persoon.setVnaam(Request.Params["vnaam"]);
				persoon.save();
				Session["deelnemer_id"] = persoon.getId().ToString();
				setCookie(Response,"deelnemer_quiz_id",persoon.getId().ToString());
				Response.Redirect(Request.Path+"?ac=home");
			}
		}else if(ac.Equals("home")){
			if (Session["deelnemer_id"] == null){
				Response.Redirect(Request.Path+"?ac=getlogin");
			}else{
				// Call the control
				Thuis myControl = (Thuis) Page.LoadControl("includes\\quiz\\home.ascx");
				myControl.deelnemerId = Session["deelnemer_id"].ToString(); // 0 --> new
				PlaceHolder.Controls.Add(myControl);
			}
		}else if(ac.Equals("quiz")){
			if (Session["deelnemer_id"] == null){
				Response.Redirect(Request.Path+"?ac=getlogin");
			}else{
				if (!Request.HttpMethod.Equals("POST")){
					// Call the control
					VraagForm myControl = (VraagForm)Page.LoadControl("includes\\quiz\\vraag.ascx");
					myControl.deelnemerId = Session["deelnemer_id"].ToString(); // 0 --> new
					myControl.quizId = Request.Params["id"].ToString();
					myControl.vraagId = Request.Params["vraag"];
					PlaceHolder.Controls.Add(myControl);
				}else{ //update
					String quizId = Request.Params["quizId"].ToString();
					String vraagId = Request.Params["vraagId"].ToString();
					String antwoord = "0";
					if (Request.Params["antwoord"]!=null) antwoord = Request.Params["antwoord"].ToString();
					//haal eerst nog eens de vraag op met het juiste antwoord_id, kan eigenlijk door een Session["antwoord_id"]
					Vraag vraag = new Vraag(vraagId);
					int antwoordId = vraag.getAntwoordId();
					bool antwoordOK = false;
					if (vraag.getType()==2){ //open vraag
						Antwoord antwoordObj = new Antwoord(antwoordId);
						if (antwoordObj.getTitel().Equals(antwoord)){
							antwoordOK = true;
							antwoord = antwoordId.ToString();
						}else{
							if(antwoord.Equals("-1")) antwoordOK = true; //eigenlijk niet maar voor de flow wel
							else antwoord = "0"; //--> klaarzetten om te bewaren in de log
						}
					} else { //radio buttons
						if (antwoordId.ToString().Equals(antwoord)) antwoordOK = true;
					}
					//Log het antwoord: vraag_id,deelnemer_id en antwoord_id
					LogQuiz logger = new LogQuiz();
					logger.setDeelnemerId(Session["deelnemer_id"].ToString());
					logger.setVraagId(vraagId);
					logger.setAntwoordId(antwoord);
					logger.save();
					if (antwoordOK){
						//volgende vraag
						Response.Redirect(Request.Path+"?ac=quiz&id="+quizId);
					}else{
						//zelfde vraag met vraagID meegegeven
						Response.Redirect(Request.Path+"?ac=quiz&id="+quizId+"&vraag="+vraagId.ToString());
					}
				}
			}
		}else if(ac.Equals("rapport")){
			if (Session["deelnemer_id"] == null){
				Response.Redirect(Request.Path+"?ac=getlogin");
			}else{
			// Call the control
				Rapport myControl = (Rapport)Page.LoadControl("includes\\quiz\\rapport.ascx");
				myControl.deelnemerId = Session["deelnemer_id"].ToString(); // 0 --> new
				myControl.quizId = Request.Params["id"].ToString();
				PlaceHolder.Controls.Add(myControl);
			}
		}else if(ac.Equals("new")){
			if (Session["deelnemer_id"] != null){
				LogQuiz logger = new LogQuiz();
				logger.setAfgewerkt(Request.Params["id"].ToString(),Session["deelnemer_id"].ToString());
			}
			Response.Redirect(Request.Path+"?ac=getlogin");
		}else if(ac.Equals("logout")){
			Session["deelnemer_id"] = null;
			setCookie(Response,"deelnemer_quiz_id","","01/01/2000");
			Response.Redirect(Request.Path+"?ac=getlogin");
		}else if(ac.Equals("sendrapport")){
			EmailRapport emailRapport = new EmailRapport();
			strResult = emailRapport.send();
		}else if(ac.Equals("showrapport")){
			EmailRapport emailRapport = new EmailRapport();
			emailRapport.show();
			strResult = emailRapport.send();
		}

		outError.InnerHtml = DB.getLog();
		DB.clearLog();
		outResult.InnerHtml = strResult;
	}
	
	public void setCookie(HttpResponse res,string name, string value, string ExpiryDate){
		HttpCookie ObjCookie;
		DateTime dtm = new DateTime();
		dtm = DateTime.Parse(ExpiryDate);
		ObjCookie = new HttpCookie(name, value);
		ObjCookie.Expires = dtm;
				
		try{res.Cookies.Add(ObjCookie);}
		catch (InvalidCastException ex){}
	}
	public void setCookie(HttpResponse res,string name, string value){
		setCookie(res,name,value,"12/12/2011");
	}
</script>