using System;
using System.Data;
using System.Data.OleDb;
using System.Collections;
using System.Text;
using System.IO;
using System.Web;

namespace Reuzenhuis.Be.Quiz {
	/**
	* DB
	*/
	public class DB{
		private static string _error = "";
		public static void setLog(string error){
			_error += error+"<br/>";
		}
		public static string getLog(){
			return _error;
		}
		public static void clearLog(){
			_error = "";
		}
		public static string strConnect = Reuzenhuis.Be.Settings.Quiz.strConnect;
		public static string resourcePath = Reuzenhuis.Be.Settings.Quiz.resourcePath;
	}
	/**
	* PERSOON
	*/
	public class Persoon {
		string naam = "";
		string vnaam = "";
		int id = 0;
		String strConnect = DB.strConnect;
		
		public void setNaam(String naam){
			this.naam = naam;
		}
		public void setVnaam(String vnaam){
			this.vnaam = vnaam;
		}
		public int getId(){
			return id;
		}
		public String getNaam(){
			return naam;
		}
		public String getVnaam(){
			return vnaam;
		}
		public Persoon() {
			//initialise
		}
		public Persoon(string strId){
			int temp = 0;
			if (strId !=null) temp = Convert.ToInt32(strId);
			load(temp);
		}
		public Persoon(object obj){
			int temp = 0;
			if (obj !=null) temp = Convert.ToInt32(obj.ToString());
			load(temp);
		}
		public Persoon(int id){
			load(id);
		}
		private void load(int id){
			this.id=id;
			OleDbConnection objConnect = null;
			OleDbCommand objCommand = null;
			OleDbDataReader objDataReader = null;
			String strSelect = "SELECT Naam,vnaam from deelnemer where id="+id;
			try {
				objConnect = new OleDbConnection(strConnect);
				objConnect.Open();
				objCommand = new OleDbCommand(strSelect, objConnect);
				objDataReader = objCommand.ExecuteReader();
				if (objDataReader.Read()) {
					naam = objDataReader["naam"].ToString();
					vnaam = objDataReader["vnaam"].ToString();
				}
			} 
			catch (Exception objError)	{DB.setLog(objError.ToString());}
			finally {
				if (objDataReader != null) objDataReader.Close();
				if (objConnect != null) objConnect.Close();
			}
		}
		public void save(){
			OleDbConnection objConnect = null;
			OleDbCommand objCommand = null;
			try	{
				objConnect = new OleDbConnection(strConnect);
				objConnect.Open();
				objCommand = new OleDbCommand();
				objCommand.Connection = objConnect;
				if (id!=0){
					//update record
					objCommand.CommandText = "update deelnemer set naam = ?, vnaam = ? where id =?;";
					objCommand.Parameters.Add(new OleDbParameter("naam", OleDbType.VarChar,50));
					objCommand.Parameters.Add(new OleDbParameter("vnaam", OleDbType.VarChar,50));
					objCommand.Parameters.Add(new OleDbParameter("id", OleDbType.Integer));
					objCommand.Prepare();
					objCommand.Parameters["naam"].Value = naam;
					objCommand.Parameters["vnaam"].Value = vnaam;
					objCommand.Parameters["id"].Value = id;
					objCommand.ExecuteNonQuery();
				}else{
					//maak nieuw record
					objCommand.CommandText = "insert into deelnemer (naam,vnaam)  Values (?,?)";
					objCommand.Parameters.Add(new OleDbParameter("naam", OleDbType.VarChar,50));
					objCommand.Parameters.Add(new OleDbParameter("vnaam", OleDbType.VarChar,50));
					objCommand.Prepare();
					objCommand.Parameters["naam"].Value = naam;				
					objCommand.Parameters["vnaam"].Value = vnaam;
					objCommand.ExecuteNonQuery();
					//get last id
					objCommand.Parameters.Clear();
					objCommand.CommandText = "SELECT @@IDENTITY";
					id = Convert.ToInt32(objCommand.ExecuteScalar());
				}
				
				
			} catch (Exception objError){
				DB.setLog(objError.Message);
			} finally {
				if (objConnect != null) objConnect.Close();
			}
			return;
		}
	}
	/**
	* LOG
	*/
	public class LogQuiz {
		int deelnemerId = 0;
		int vraagId = 0;
		int antwoordId = 0;
		int afgewerkt = 0;
		DateTime timestamp = new DateTime();
		int id = 0;
		String strConnect = DB.strConnect;
		
		public void setDeelnemerId(int deelnemerId){
			this.deelnemerId = deelnemerId;
		}
		public void setDeelnemerId(string deelnemerId){
			this.deelnemerId = Convert.ToInt32(deelnemerId);
		}
		public void setVraagId(int vraagId){
			this.vraagId = vraagId;
		}
		public void setVraagId(string vraagId){
			this.vraagId = Convert.ToInt32(vraagId);
		}
		public void setAntwoordId(int antwoordId){
			this.antwoordId = antwoordId;
		}
		public void setAntwoordId(string antwoordId){
			this.antwoordId = Convert.ToInt32(antwoordId);
		}
		public void setAfgewerkt(int afgewerkt){
			this.afgewerkt = afgewerkt;
		}
		public int getId(){
			return id;
		}
		public int getDeelnemerId(){
			return deelnemerId;
		}
		public DateTime getTimestamp(){
			return timestamp;
		}
		public LogQuiz() {
			//initialise
		}
		public LogQuiz(string strId){
			int temp = 0;
			if (strId !=null) temp = Convert.ToInt32(strId);
			load(temp);
		}
		public LogQuiz(object obj){
			int temp = 0;
			if (obj !=null) temp = Convert.ToInt32(obj.ToString());
			load(temp);
		}
		public LogQuiz(int id){
			load(id);
		}
		private void load(int id){
			this.id=id;
			OleDbConnection objConnect = null;
			OleDbCommand objCommand = null;
			OleDbDataReader objDataReader = null;
			String strSelect = "SELECT deelnemer_id,vraag_id,antwoord_id,timestamp,afgewerkt from log where id="+id;
			try {
				objConnect = new OleDbConnection(strConnect);
				objConnect.Open();
				objCommand = new OleDbCommand(strSelect, objConnect);
				objDataReader = objCommand.ExecuteReader();
				if (objDataReader.Read()) {
					deelnemerId = Convert.ToInt32(objDataReader["deelnemer_id"]);
					//vnaam = objDataReader["vnaam"].ToString();
				}
			} 
			catch (Exception objError)	{DB.setLog(objError.ToString());}
			finally {
				if (objDataReader != null) objDataReader.Close();
				if (objConnect != null) objConnect.Close();
			}
		}
		public void save(){
			OleDbConnection objConnect = null;
			OleDbCommand objCommand = null;
			try	{
				objConnect = new OleDbConnection(strConnect);
				objConnect.Open();
				objCommand = new OleDbCommand();
				objCommand.Connection = objConnect;
				if (id!=0){
					//update record
					objCommand.CommandText = "update log set deelnemer_id = ?, vraag_id = ?,antwoord_id=?,timestamp=?,afgewerkt=? where id =?;";
					objCommand.Parameters.Add(new OleDbParameter("deelnemer_id", OleDbType.Integer));
					objCommand.Parameters.Add(new OleDbParameter("vraag_id", OleDbType.Integer));
					objCommand.Parameters.Add(new OleDbParameter("antwoord_id", OleDbType.Integer));
					objCommand.Parameters.Add(new OleDbParameter("timestamp", OleDbType.Date));
					objCommand.Parameters.Add(new OleDbParameter("afgewerkt", OleDbType.Integer));
					objCommand.Parameters.Add(new OleDbParameter("id", OleDbType.Integer));
					objCommand.Prepare();
					objCommand.Parameters["deelnemer_id"].Value = deelnemerId;
					objCommand.Parameters["vraag_id"].Value = vraagId;
					objCommand.Parameters["antwoord_id"].Value = antwoordId;
					objCommand.Parameters["timestamp"].Value = timestamp;
					objCommand.Parameters["afgewerkt"].Value = afgewerkt;
					objCommand.Parameters["id"].Value = id;
					objCommand.ExecuteNonQuery();
				}else{
					//maak nieuw record
					objCommand.CommandText = "insert into log (deelnemer_id,vraag_id,antwoord_id)  Values (?,?,?)";
					objCommand.Parameters.Add(new OleDbParameter("deelnemer_id", OleDbType.Integer));
					objCommand.Parameters.Add(new OleDbParameter("vraag_id", OleDbType.Integer));
					objCommand.Parameters.Add(new OleDbParameter("antwoord_id", OleDbType.Integer));
					objCommand.Prepare();
					objCommand.Parameters["deelnemer_id"].Value = deelnemerId;
					objCommand.Parameters["vraag_id"].Value = vraagId;
					objCommand.Parameters["antwoord_id"].Value = antwoordId;
					objCommand.ExecuteNonQuery();
					//get last id
					objCommand.Parameters.Clear();
					objCommand.CommandText = "SELECT @@IDENTITY";
					id = Convert.ToInt32(objCommand.ExecuteScalar());
				}
				
				
			} catch (Exception objError){
				DB.setLog(objError.Message);
			} finally {
				if (objConnect != null) objConnect.Close();
			}
			return;
		}
		public ArrayList getRapport(string quizId,string deelnemerId){
			return getRapport(quizId,deelnemerId,"0");
		}
		public ArrayList getRapport(string quizId,string deelnemerId,string afgewerkt){
			ArrayList rapport = new ArrayList();
			OleDbConnection objConnect = null;
			OleDbCommand objCommand = null;
			OleDbDataReader objDataReader = null;
			String strSelect = "SELECT Log.vraag_id, Count(Log.vraag_id) AS teller FROM Vragen INNER JOIN Log ON Vragen.id = Log.vraag_id Where Log.deelnemer_id = "+deelnemerId+" And Log.vraag_id IN (select id from Vragen where quizid="+quizId+") And Log.afgewerkt="+afgewerkt+" GROUP BY Log.vraag_id, Log.deelnemer_id, Vragen.volgorde ORDER BY Vragen.volgorde;";
			try {
				objConnect = new OleDbConnection(strConnect);
				objConnect.Open();
				objCommand = new OleDbCommand(strSelect, objConnect);
				objDataReader = objCommand.ExecuteReader();
				while (objDataReader.Read()) {
					rapport.Add(objDataReader["vraag_id"]);
					rapport.Add(objDataReader["teller"]);
				}
			} 
			catch (Exception objError)	{DB.setLog(objError.ToString());}
			finally {
				if (objDataReader != null) objDataReader.Close();
				if (objConnect != null) objConnect.Close();
			}
			return rapport;
		}
		public TimeSpan getRapportTime(string quizId,string deelnemerId){
			return getRapportTime(quizId,deelnemerId,"0");
		}
		public TimeSpan getRapportTime(string quizId,string deelnemerId,string afgewerkt){
			OleDbConnection objConnect = null;
			OleDbCommand objCommand = null;
			OleDbDataReader objDataReader = null;
			String strSelect = "SELECT Log.timestamp FROM Log Where Log.deelnemer_id = "+deelnemerId+" And Log.vraag_id IN (select id from Vragen where quizid="+quizId+") And Log.afgewerkt="+afgewerkt+";";
			DateTime timestampEnd = new DateTime();
			try {
				objConnect = new OleDbConnection(strConnect);
				objConnect.Open();
				objCommand = new OleDbCommand(strSelect, objConnect);
				objDataReader = objCommand.ExecuteReader();
				bool first = true;
				while (objDataReader.Read()) {
					if (first){
						timestamp = DateTime.Parse(objDataReader["timestamp"].ToString());
						first = false;
					}
					timestampEnd = DateTime.Parse(objDataReader["timestamp"].ToString());
				}				
			} 
			catch (Exception objError)	{DB.setLog(objError.ToString());}
			finally {
				if (objDataReader != null) objDataReader.Close();
				if (objConnect != null) objConnect.Close();
			}
			return timestampEnd.Subtract(timestamp);
		}
		public bool opgegeven(string vraagId,string deelnemerId){
			bool theReturn = false;
			OleDbConnection objConnect = null;
			OleDbCommand objCommand = null;
			OleDbDataReader objDataReader = null;
			String strSelect = "SELECT count(id) as teller FROM Log Where Log.deelnemer_id = "+deelnemerId+" And Log.vraag_id = "+vraagId+" And antwoord_id = -1 And Log.afgewerkt=0;";
			try {
				objConnect = new OleDbConnection(strConnect);
				objConnect.Open();
				objCommand = new OleDbCommand(strSelect, objConnect);
				objDataReader = objCommand.ExecuteReader();
				if (objDataReader.Read()) {
					if (Convert.ToInt32(objDataReader["teller"]) >0) theReturn = true;
				}
			} 
			catch (Exception objError)	{DB.setLog(objError.ToString());}
			finally {
				if (objDataReader != null) objDataReader.Close();
				if (objConnect != null) objConnect.Close();
			}
			return theReturn;
		}
		public void setAfgewerkt(string quizId,string deelnemerId){
			OleDbConnection objConnect = null;
			OleDbCommand objCommand = null;
			try	{
				objConnect = new OleDbConnection(strConnect);
				objConnect.Open();
				objCommand = new OleDbCommand();
				objCommand.Connection = objConnect;
				objCommand.CommandText = "update log set afgewerkt="+nextAfgewerkt()+" where deelnemer_id = "+deelnemerId+" AND vraag_id IN (select id from Vragen where quizid="+quizId+") and afgewerkt=0;";
				objCommand.ExecuteNonQuery();			
			} catch (Exception objError){
				DB.setLog(objError.Message);
			} finally {
				if (objConnect != null) objConnect.Close();
			}
			return;
		}
		private string nextAfgewerkt(){
			int theReturn = 1;
			OleDbConnection objConnect = null;
			OleDbCommand objCommand = null;
			OleDbDataReader objDataReader = null;
			String strSelect = "SELECT Top 1 afgewerkt FROM Log Order by afgewerkt desc;";
			try {
				objConnect = new OleDbConnection(strConnect);
				objConnect.Open();
				objCommand = new OleDbCommand(strSelect, objConnect);
				objDataReader = objCommand.ExecuteReader();
				if (objDataReader.Read()) {
					theReturn = Convert.ToInt32(objDataReader["afgewerkt"])+1;
				}
			} 
			catch (Exception objError)	{DB.setLog(objError.ToString());}
			finally {
				if (objDataReader != null) objDataReader.Close();
				if (objConnect != null) objConnect.Close();
			}
			return theReturn.ToString();
		}
	}
	/**
	* VRAAG
	*/
	public class Vraag {
		string titel = "";
		int type = 0;
		int vraagId = 0;
		int antwoordId = 0;
		int quizId = 0;
		int deelnemerId = 0;
		int punten = 0;
		String resource = "";
		String strConnect = DB.strConnect;
		
		public void setDeelnemerId(int deelnemerId){
			this.deelnemerId = deelnemerId;
		}
		public int getId(){
			return vraagId;
		}
		public String getTitel(){
			return titel;
		}
		public int getType(){
			return type;
		}
		public int getPunten(){
			return punten;
		}
		public String getVraagId(){
			return vraagId.ToString();
		}
		public int getAntwoordId(){
			return antwoordId;
		}
		public String getResource(){
			return resource;
		}
		public Vraag() {
			//initialise
		}
		public Vraag(string strId){
			int temp = 0;
			if (strId !=null) temp = Convert.ToInt32(strId);
			load(temp);
		}
		public Vraag(object obj){
			int temp = 0;
			if (obj !=null) temp = Convert.ToInt32(obj.ToString());
			load(temp);
		}
		public Vraag(int id){
			load(id);
		}
		public Vraag(int quiz_id,int deelnemerId){
			load2(quiz_id,deelnemerId);
		}
		public Vraag(string quiz_id,string deelnemerId){
			load2(Convert.ToInt32(quiz_id),Convert.ToInt32(deelnemerId));
		}
		private void load(int id){
			this.vraagId=id;
			OleDbConnection objConnect = null;
			OleDbCommand objCommand = null;
			OleDbDataReader objDataReader = null;
			String strSelect = "SELECT Vragen.vraag, Antwoorden.type,Antwoorden.punten, Vragen.id AS vraag_id, Antwoorden.id AS antwoord_id, Resources.id as resId, Resources.ext FROM (Vragen INNER JOIN Antwoorden ON Vragen.id = Antwoorden.vraagid) LEFT OUTER JOIN Resources ON Vragen.id = Resources.vraagid where Vragen.id="+id+" Order by Vragen.volgorde asc,Antwoorden.punten desc;";
			try {
				objConnect = new OleDbConnection(strConnect);
				objConnect.Open();
				objCommand = new OleDbCommand(strSelect, objConnect);
				objDataReader = objCommand.ExecuteReader();
				if (objDataReader.Read()) {
					titel = objDataReader["vraag"].ToString();
					type = Convert.ToInt32(objDataReader["type"]);
					punten = Convert.ToInt32(objDataReader["punten"]);
					vraagId = Convert.ToInt32(objDataReader["vraag_id"]);
					antwoordId = Convert.ToInt32(objDataReader["antwoord_id"]);
					if (!objDataReader["resId"].ToString().Equals("")) resource = "<img src=\"/quiz/res/quiz"+objDataReader["resId"].ToString()+"."+objDataReader["ext"].ToString()+"\" width=\""+imageWidth(objDataReader["resId"].ToString()+"."+objDataReader["ext"].ToString())+"\">";
				}
			} 
			catch (Exception objError)	{DB.setLog(objError.ToString());}
			finally {
				if (objDataReader != null) objDataReader.Close();
				if (objConnect != null) objConnect.Close();
			}
		}
		private void load2(int quizId,int deelnemerId){
			this.quizId=quizId;
			this.deelnemerId=deelnemerId;
			OleDbConnection objConnect = null;
			OleDbCommand objCommand = null;
			OleDbDataReader objDataReader = null;
			String strSelect = "SELECT Vragen.vraag, Antwoorden.type, Vragen.id AS vraag_id, Antwoorden.id AS antwoord_id, Resources.id as resId, Resources.ext FROM (Vragen INNER JOIN Antwoorden ON Vragen.id = Antwoorden.vraagid) LEFT OUTER JOIN Resources ON Vragen.id = Resources.vraagid where  Vragen.quizid="+quizId+" AND Vragen.id not IN(select vraag_id from Log where deelnemer_id = "+deelnemerId+" and afgewerkt=0) Order by Vragen.volgorde asc,Antwoorden.punten desc;";
			try {
				objConnect = new OleDbConnection(strConnect);
				objConnect.Open();
				objCommand = new OleDbCommand(strSelect, objConnect);
				objDataReader = objCommand.ExecuteReader();
				if (objDataReader.Read()) {
					titel = objDataReader["vraag"].ToString();
					type = Convert.ToInt32(objDataReader["type"]);
					vraagId = Convert.ToInt32(objDataReader["vraag_id"]);
					antwoordId = Convert.ToInt32(objDataReader["antwoord_id"]);
					if (!objDataReader["resId"].ToString().Equals("")) resource = "<img src=\"/quiz/res/quiz"+objDataReader["resId"].ToString()+"."+objDataReader["ext"].ToString()+"\" width=\""+imageWidth(objDataReader["resId"].ToString()+"."+objDataReader["ext"].ToString())+"\">";
				}
			} 
			catch (Exception objError)	{DB.setLog(objError.ToString());}
			finally {
				if (objDataReader != null) objDataReader.Close();
				if (objConnect != null) objConnect.Close();
			}
		}
		private String imageWidth(String fileName){
	        int fileWidth;
	        //int fileHeight;
	        FileStream fs = new FileStream(DB.resourcePath + fileName, FileMode.Open, FileAccess.Read, FileShare.Read);
	        using(System.Drawing.Image image = System.Drawing.Image.FromStream(fs))
	        {
	          fileWidth = image.Width;
	          //fileHeight = image.Height;
	        }
	        fs.Close();
	        fs = null;
			if (fileWidth > 250) fileWidth=250;
			return fileWidth.ToString();
		}
	}
	/**
	* Quiz
	*/
	public class Quiz {
		int id = 0;
		string titel = "";
		string oms = "";
		int groep = 0;
		int thema = 0;
		bool online = false;
		int school = 0;
		String strConnect = DB.strConnect;
		
		public int getId(){
			return id;
		}
		public String getTitel(){
			return titel;
		}
		public String getOms(){
			return oms;
		}
		public int getGroep(){
			return groep;
		}
		public int getThema(){
			return thema;
		}
		public bool getOnline(){
			return online;
		}
		public int getSchool(){
			return school;
		}
		public Quiz() {
			//initialise
		}
		public Quiz(string strId){
			int temp = 0;
			if (strId !=null) temp = Convert.ToInt32(strId);
			load(temp);
		}
		public Quiz(object obj){
			int temp = 0;
			if (obj !=null) temp = Convert.ToInt32(obj.ToString());
			load(temp);
		}
		public Quiz(int id){
			load(id);
		}
		private void load(int id){
			this.id=id;
			OleDbConnection objConnect = null;
			OleDbCommand objCommand = null;
			OleDbDataReader objDataReader = null;
			String strSelect = "SELECT titel,oms,groep,thema,online,school FROM Quiz where id = "+id;
			try {
				objConnect = new OleDbConnection(strConnect);
				objConnect.Open();
				objCommand = new OleDbCommand(strSelect, objConnect);
				objDataReader = objCommand.ExecuteReader();
				if (objDataReader.Read()) {
					titel = objDataReader["titel"].ToString();
					oms = objDataReader["oms"].ToString();
					groep = Convert.ToInt32(objDataReader["groep"]);
					thema = Convert.ToInt32(objDataReader["thema"]);
					if (Convert.ToInt32(objDataReader["online"])==1) online = true; else online = false;
					school = Convert.ToInt32(objDataReader["school"]);
				}
			} 
			catch (Exception objError)	{DB.setLog(objError.ToString());}
			finally {
				if (objDataReader != null) objDataReader.Close();
				if (objConnect != null) objConnect.Close();
			}
		}
	}
	/**
	* ANTWOORD
	*/
	public class Antwoord {
		int id = 0;
		string titel = "";
		int type = 0;
		int vraagId = 0;
		int punten = 0;
		String tip = "";
		String strConnect = DB.strConnect;
		

		public int getId(){
			return id;
		}
		public String getTitel(){
			return titel;
		}
		public int getType(){
			return type;
		}
		public String getVraagId(){
			return vraagId.ToString();
		}
		public int getAntwoordId(){
			return id;
		}
		public String getTip(){
			return tip;
		}
		public Antwoord() {
			//initialise
		}
		public Antwoord(string strId){
			int temp = 0;
			if (strId !=null) temp = Convert.ToInt32(strId);
			load(temp);
		}
		public Antwoord(object obj){
			int temp = 0;
			if (obj !=null) temp = Convert.ToInt32(obj.ToString());
			load(temp);
		}
		public Antwoord(int id){
			load(id);
		}

		private void load(int id){
			this.id=id;
			OleDbConnection objConnect = null;
			OleDbCommand objCommand = null;
			OleDbDataReader objDataReader = null;
			String strSelect = "SELECT vraagid,antwoord,punten,uitleg,type FROM antwoorden Where id = "+id;
			try {
				objConnect = new OleDbConnection(strConnect);
				objConnect.Open();
				objCommand = new OleDbCommand(strSelect, objConnect);
				objDataReader = objCommand.ExecuteReader();
				if (objDataReader.Read()) {
					vraagId = Convert.ToInt32(objDataReader["vraagid"]);
					titel = objDataReader["antwoord"].ToString();
					punten = Convert.ToInt32(objDataReader["punten"]);
					tip = objDataReader["uitleg"].ToString();
					type = Convert.ToInt32(objDataReader["type"]);
				}
			} 
			catch (Exception objError)	{DB.setLog(objError.ToString());}
			finally {
				if (objDataReader != null) objDataReader.Close();
				if (objConnect != null) objConnect.Close();
			}
		}
		public ArrayList getAntwoorden(int vraagId){
			ArrayList antwoorden = new ArrayList();
			OleDbConnection objConnect = null;
			OleDbCommand objCommand = null;
			OleDbDataReader objDataReader = null;
			String strSelect = "SELECT id,antwoord,uitleg FROM antwoorden where vraagid ="+vraagId+";";
			try {
				objConnect = new OleDbConnection(strConnect);
				objConnect.Open();
				objCommand = new OleDbCommand(strSelect, objConnect);
				objDataReader = objCommand.ExecuteReader();
				while (objDataReader.Read()) {
					antwoorden.Add(objDataReader["id"].ToString());
					antwoorden.Add(objDataReader["antwoord"].ToString());
					antwoorden.Add(objDataReader["uitleg"].ToString());
				}
			} 
			catch (Exception objError)	{DB.setLog(objError.ToString());}
			finally {
				if (objDataReader != null) objDataReader.Close();
				if (objConnect != null) objConnect.Close();
			}
			return antwoorden;
		}
		public ArrayList getVerkeerdeAntwoorden(int vraagId,int deelnemerId){
			ArrayList antwoorden = new ArrayList();
			OleDbConnection objConnect = null;
			OleDbCommand objCommand = null;
			OleDbDataReader objDataReader = null;
			String strSelect = "SELECT antwoord_id FROM log where vraag_id ="+vraagId+" And deelnemer_id = "+deelnemerId+" And afgewerkt = 0;";
			try {
				objConnect = new OleDbConnection(strConnect);
				objConnect.Open();
				objCommand = new OleDbCommand(strSelect, objConnect);
				objDataReader = objCommand.ExecuteReader();
				while (objDataReader.Read()) {
					antwoorden.Add(objDataReader["antwoord_id"]);
				}
			} 
			catch (Exception objError)	{DB.setLog(objError.ToString());}
			finally {
				if (objDataReader != null) objDataReader.Close();
				if (objConnect != null) objConnect.Close();
			}
			return antwoorden;
		}
	}
	/**
	* EmailRapport
	*/
	public class EmailRapport {
		String strConnect = DB.strConnect;
		String emailFrom = "webmaster@reuzenhuis.be";
		String emailTo = "quiz@reuzenhuis.be";
		String subject = "Rapporten quiz "+DateTime.Now.ToString("dd/MM/yyyy");
		StringBuilder body = new StringBuilder();
		bool showIt = false;
		public void show(){
			showIt = true;
		}
		public EmailRapport() {
			//initialise
		}
		public string send(){
			ArrayList rapporten = getRapporten();
			body.Append("<html><head>").Append(css()).Append("</head><body>");
			body.Append("<table cellpadding=\"2\" cellspacing=\"0\" width=\"100%\">");
			//doorloop de te verzenden rapporten
			for(int j=0;j<rapporten.Count;j=j+3){
				String deelnemerId = rapporten[j].ToString();
				String quizId = rapporten[j+1].ToString();
				String afgewerkt = rapporten[j+2].ToString();
				int totaalPunten = 0;
				int maxPunten = 0;
				int totaalPogingen = 0;
				String pogingen = "";
				//haal de quiztijd en startTijd
				LogQuiz logger = new LogQuiz();
				TimeSpan quizTime = logger.getRapportTime(quizId,deelnemerId,afgewerkt);
				//De deelnemer
				Persoon persoon = new Persoon(deelnemerId);
				body.Append("<tr><td colspan=\"3\" class=\"subtitel\">").Append(persoon.getVnaam()).Append(" ").Append(persoon.getNaam()).Append("</td></tr>");
				body.Append("<tr><td colspan=\"3\">").Append(logger.getTimestamp().AddHours(9).ToString("dd/MM/yyy HH:mm")).Append("</td></tr>");  //9uur erbij hosting in Amerika
				//haal de QuizTitel
				Quiz quiz = new Quiz(quizId);
				body.Append("<tr><td class=\"subtitel\">").Append(quiz.getTitel()).Append("</td><td class=\"subtitel\">Punten</td><td class=\"subtitel\">Pogingen</td></tr>");
				//haal het rapport
				ArrayList rapport = logger.getRapport(quizId,deelnemerId,afgewerkt);
				//door loop dit rapport en voeg het toe aan de email
				for(int i=0;i<rapport.Count;i=i+2){
					Vraag vraag = new Vraag(rapport[i]);
					int punten = 0;
					//indien type==2 dan ook controleren of er niet geskipt is
					if(vraag.getType()==2){
						if(logger.opgegeven(rapport[i].ToString(),deelnemerId)){
							pogingen = "opgegeven";
						} else{
							pogingen = rapport[i+1].ToString();
							punten = vraag.getPunten();
							totaalPogingen += Convert.ToInt32(rapport[i+1]);
						}
					}else{
						if (Convert.ToInt32(rapport[i+1])==1) punten = vraag.getPunten();
						pogingen = rapport[i+1].ToString();
						totaalPogingen += Convert.ToInt32(rapport[i+1]);
					}
					maxPunten += vraag.getPunten();
					totaalPunten += punten;
					body.Append("<tr><td>").Append(vraag.getTitel()).Append("</td><td>").Append(punten.ToString()).Append("</td><td>").Append(pogingen).Append("</td></tr>");
				}
				body.Append("<tr><td colspan=\"3\" style=\"background-color:#cccccc;\"></td></tr>");
				body.Append("<tr><td class=\"subtitel\">Tijd nodig: ").Append(quizTime.Minutes.ToString()).Append(" min ").Append(quizTime.Seconds.ToString()).Append(" sec</td><td class=\"subtitel\">").Append(totaalPunten.ToString()).Append("/").Append(maxPunten.ToString()).Append("</td><td class=\"subtitel\">").Append(totaalPogingen.ToString()).Append("</td></tr>");
				body.Append("<tr><td colspan=\"3\">&nbsp;</td></tr>");
			}
			body.Append("</table></body></html>");
			if (!showIt) return sendEmail(emailTo,emailFrom,subject,body.ToString(),System.Web.Mail.MailFormat.Html);
			else return body.ToString();
		}
		private string sendEmail(string To, string From, string Subject, string Body, System.Web.Mail.MailFormat Format){
	  		try{
		        System.Web.Mail.MailMessage Mailer = new System.Web.Mail.MailMessage();
		        Mailer.From = From;
		        Mailer.To = To;
		        Mailer.Subject = Subject;
		        Mailer.Body = Body;
		        Mailer.BodyFormat = Format;
				System.Web.Mail.SmtpMail.SmtpServer = "mail.reuzenhuis.be";
		        System.Web.Mail.SmtpMail.Send(Mailer);
				return "";
	  		}catch(Exception ex){
	    		return ex.ToString();
	  		}
    	}
		private StringBuilder css(){
			StringBuilder sb = new StringBuilder();
			sb.Append("<style>");
			sb.Append("td,td.search,p,dic,span,input,select,textarea,li,lu,div,body { 	font-family: Verdana, Arial, Helvetica, sans-serif;	font-size: 12px; color: #666666;}");
			sb.Append(".titel,.maintitel{font-family: Tahoma,Verdana, Arial, Helvetica, sans-serif;font-weight : bold;font-size : 18px;}");
			sb.Append("td.titelitem{font-weight : bold;font-size : 14px;}");
			sb.Append(".subtitel,.subtitell{font-weight : bold;}");
			sb.Append(".specialbold{	color: #CC9933;	font-weight : bold;}");
			sb.Append("A,A:active,A:visited,A:link{font-size: 12px;color: #666666;text-decoration: underline;font-weight : bold;}");
			sb.Append("A:hover {font-size: 12px;color: #CC9933;text-decoration: underline;}");
			sb.Append("</style>");
			return sb;
		}
		private ArrayList getRapporten(){
			return getRapporten("7");
		}
		private ArrayList getRapporten(string aantalDagen){
			ArrayList rapporten = new ArrayList();
			OleDbConnection objConnect = null;
			OleDbCommand objCommand = null;
			OleDbDataReader objDataReader = null;
			String strSelect = "SELECT Log.deelnemer_id, Vragen.quizid, Log.afgewerkt FROM Vragen INNER JOIN Log ON Vragen.id = Log.vraag_id WHERE (((Log.timestamp)>DateAdd('d',-"+aantalDagen+",Now()))) GROUP BY Log.deelnemer_id, Vragen.quizid, Log.afgewerkt, Log.deelnemer_id;";
			try {
				objConnect = new OleDbConnection(strConnect);
				objConnect.Open();
				objCommand = new OleDbCommand(strSelect, objConnect);
				objDataReader = objCommand.ExecuteReader();
				while (objDataReader.Read()) {
					rapporten.Add(objDataReader["deelnemer_id"].ToString());
					rapporten.Add(objDataReader["quizid"].ToString());
					rapporten.Add(objDataReader["afgewerkt"].ToString());
				}
			} 
			catch (Exception objError)	{DB.setLog(objError.ToString());}
			finally {
				if (objDataReader != null) objDataReader.Close();
				if (objConnect != null) objConnect.Close();
			}
			return rapporten;
		}
	}
}